#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

vector<vi> g;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, ggg;
    cin >> n >> m >> ggg;

    g.resize(n);
    // gg.resize(n);
    
    int ans = 0;

    map<pi, int> used;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].pb(v);
        // edges.pb({u, v});

        pi e = {u, v};
        // cout << "v " << v - u << endl;
        if (used[e] || (((u + 1) % 2) != v)) ++ans;

        // if (v - u > 1) ++ans;

        // gg[u].pb(edges.size() - 1);
        // gg[v].pb(edges.size() - 1);
    }

    cout << ans << endl << 1;
}